#include "VertexFormat.h"

#include <iostream>

using namespace std;
using namespace GPUmesh;

typedef TYPELIST_3(mvf_vertex_3f,mvf_normal_3f,mvf_color0_rgba) mvf_1;
typedef TYPELIST_2(mvf_vertex_3f,mvf_color0_rgba)               mvf_2;

int main(int argc,char **argv)
{
  cerr << "typedef TYPELIST_3(mvf_vertex_3f,mvf_normal_3f,mvf_color0_rgba) mvf_1;" << endl;
  cerr << "typedef TYPELIST_2(mvf_vertex_3f,mvf_color0_rgba)               mvf_2;" << endl;

  cerr << " -------- MVF_sizeof -------- " << endl;
  cerr << "MVF_sizeof<mvf_1>::value = "
       << MVF_sizeof<mvf_1>::value << endl;
  cerr << "MVF_sizeof<mvf_2>::value = "
       << MVF_sizeof<mvf_2>::value << endl;

  cerr << " -------- MVF_is_item -------- " << endl;
  cerr << "MVF_is_item<mvf_vertex_3f,MVF_BASE_VERTEX>::value = " 
       << MVF_is_item<mvf_vertex_3f,MVF_BASE_VERTEX>::value << endl;
  cerr << "MVF_is_item<mvf_vertex_3f,MVF_BASE_NORMAL>::value = " 
       << MVF_is_item<mvf_vertex_3f,MVF_BASE_NORMAL>::value << endl;

  cerr << " -------- MVF_offset -------- " << endl;
  cerr << "MVF_offset<mvf_1,mvf_normal_3f>::value = "
       << MVF_offset<mvf_1,mvf_normal_3f>::value << endl;
  cerr << "MVF_offset<mvf_2,mvf_normal_3f>::value = "
       << MVF_offset<mvf_2,mvf_normal_3f>::value << endl;

  cerr << " -------- MVF_offset_item -------- " << endl;
  cerr << "MVF_offset_item<mvf_1,MVF_BASE_NORMAL>::value = "
       << MVF_offset_item<mvf_1,MVF_BASE_NORMAL>::value << endl;
  cerr << "MVF_offset_item<mvf_2,MVF_BASE_NORMAL>::value = "
       << MVF_offset_item<mvf_2,MVF_BASE_NORMAL>::value << endl;

  cerr << " -------- MVF_index_item -------- " << endl;
  cerr << "MVF_index_item<mvf_1,MVF_BASE_NORMAL>::value = "
       << MVF_index_item<mvf_1,MVF_BASE_NORMAL>::value << endl;
  cerr << "MVF_index_item<mvf_2,MVF_BASE_NORMAL>::value = "
       << MVF_index_item<mvf_2,MVF_BASE_NORMAL>::value << endl;

  cerr << " -------- CompatibleFormat -------- " << endl;
  cerr << "CompatibleFormat<mvf_1,mvf_2>::value = "
       << CompatibleFormat<mvf_1,mvf_2>::value << endl;
   cerr << "CompatibleFormat<mvf_2,mvf_1>::value = "
       << CompatibleFormat<mvf_2,mvf_1>::value << endl; 

  return (0);
}
